<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

require FORUM_ROOT.'include/common.php';

if (file_exists(FORUM_ROOT.'extensions/pm_search_autocomplete/lang/'.$forum_user['language'].'/pm_search_autocomplete.php'))
	require FORUM_ROOT.'extensions/pm_search_autocomplete/lang/'.$forum_user['language'].'/pm_search_autocomplete.php';
else
	require FORUM_ROOT.'extensions/pm_search_autocomplete/lang/English/pm_search_autocomplete.php';

if (isset($_GET['action']))
	define('FORUM_QUIET_VISIT', 1);

$action = isset($_GET['action']) ? $_GET['action'] : null;
$username = isset($_GET['term']) ? $_GET['term'] : null;

if ($action == 'inbox_form')
{
	global $forum_db, $forum_user;

	$query = array(
		'SELECT'	=> 'pm.id',
		'FROM'		=> 'pun_pm_messages AS pm',
		'WHERE'		=> 'pm.receiver_id=\''.$forum_user['id'].'\' AND pm.deleted_by_receiver=0 AND (pm.status = \'delivered\' OR status = \'read\')'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {

	    if (isset($_COOKIE['inbox_pm_sender']) && $_COOKIE['inbox_pm_sender'] != '') {
		
		    $query = array(
			    'SELECT'	=> 'u.username',
			    'FROM'		=> 'users AS u',
			    'WHERE'		=> 'u.id = '.$_COOKIE['inbox_pm_sender']
		    );
		    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		    $inbox_pm_sender = $forum_db->result($result);
	    }
	
	    if (isset($inbox_pm_sender)) {
		    $user = $inbox_pm_sender;
	    } else {
		    $user = '';
	    }
	
	    $inbox_form = '<fieldset class="mf-set mf-extra">
					    <legend><span>'.$pm_search_autocomplete['Search by sender name'].'</span></legend>
					    <div class="mf-box">
						    <div class="mf-field text mf-field1">
							    <span class="fld-input"><input type="text" id="inbox_pm_sender" name="inbox_pm_sender" value="'.$user.'" size="54" maxlength="50" /></span>
						    </div>
						    <div class="mf-field text">
							    <span class="submit"><input type="submit" value="'.$pm_search_autocomplete['Find'].'" onClick="PM_search.get_inbox(); return false" /> <input type="submit" value="'.$pm_search_autocomplete['Clear'].'" onClick="PM_search.clear_inbox_search(); return false" /></span>
						    </div>
					    </div>
				       </fieldset>';

	    echo json_encode(array('box'=>true, 'form'=>$inbox_form));
				
	    die;
	} else {
		echo json_encode(array('box'=>false));
				
	    die;
	}
}

if ($action == 'outbox_form')
{
	global $forum_db, $forum_user;
	
	$query = array(
		'SELECT'	=> 'pm.id',
		'FROM'		=> 'pun_pm_messages AS pm',
		'WHERE'		=> 'pm.sender_id=\''.$forum_user['id'].'\' AND pm.deleted_by_sender=0'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {

	    if (isset($_COOKIE['outbox_pm_receiver']) && $_COOKIE['outbox_pm_receiver'] != '') {
		
		    $query = array(
			    'SELECT'	=> 'u.username',
			    'FROM'		=> 'users AS u',
			    'WHERE'		=> 'u.id = '.$_COOKIE['outbox_pm_receiver']
		    );
		    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		    $outbox_pm_receiver = $forum_db->result($result);
	    }
	
	    if (isset($outbox_pm_receiver)) {
		    $user = $outbox_pm_receiver;
	    } else {
		    $user = '';
	    }
	
	    $outbox_form = '<fieldset class="mf-set mf-extra">
					    <legend><span>'.$pm_search_autocomplete['Search by receiver name'].'</span></legend>
					    <div class="mf-box">
						    <div class="mf-field text mf-field1">
							    <span class="fld-input"><input type="text" id="outbox_pm_receiver" name="outbox_pm_receiver" value="'.$user.'" size="54" maxlength="50" /></span>
						    </div>
						    <div class="mf-field text">
							    <span class="submit"><input type="submit" value="'.$pm_search_autocomplete['Find'].'" onClick="PM_search.get_outbox(); return false" /> <input type="submit" value="'.$pm_search_autocomplete['Clear'].'" onClick="PM_search.clear_outbox_search(); return false" /></span>
						    </div>
					    </div>
				    </fieldset>';

        echo json_encode(array('box'=>true, 'form'=>$outbox_form));
				
	    die;
	} else {
		echo json_encode(array('box'=>false));
				
	    die;
	}
}

else if ($action == 'inbox' && $username != null)
{
	global $forum_db, $forum_user;

	$query = array(
		'SELECT'	=> 'u.username',
		'FROM'		=> 'pun_pm_messages AS pm',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'users AS u',
				'ON'			=> '(u.id=pm.sender_id)'
			),
		),
		'WHERE'		=> 'pm.receiver_id=\''.$forum_user['id'].'\' AND pm.deleted_by_receiver=0 AND (pm.status = \'delivered\' OR status = \'read\') AND u.username LIKE \'%'.$forum_db->escape($username).'%\'',
		'GROUP BY'	=> 'username',
		'LIMIT'		=> 10
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {
		
		$data = array();
		while ($pm = $forum_db->fetch_assoc($result)) {
	           $data[] = $pm['username'];
	    }
		
		echo json_encode($data);
	   
	    die;
	}
}
	
else if ($action == 'outbox' && $username != null)
{
	global $forum_db, $forum_user;

	$query = array(
		'SELECT'	=> 'u.username',
		'FROM'		=> 'pun_pm_messages AS pm',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'users AS u',
				'ON'			=> '(u.id=pm.receiver_id)'
			),
		),
		'WHERE'		=> 'pm.sender_id=\''.$forum_user['id'].'\' AND pm.deleted_by_sender=0 AND u.username LIKE \'%'.$forum_db->escape($username).'%\'',
		'GROUP BY'	=> 'username',
		'LIMIT'		=> 10
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {
		
		$data = array();
		while ($pm = $forum_db->fetch_assoc($result)) {
	           $data[] = $pm['username'];
	    }
		
		echo json_encode($data);
	   
	    die;
	}
}

else if ($action == 'write' && $username != null)
{
	global $forum_db;
	
	$query = array(
		'SELECT'	=> 'username',
		'FROM'		=> 'users',
		'WHERE'		=> 'username !=\''.$forum_user['username'].'\' AND username !=\'guest\' AND username LIKE \'%'.$forum_db->escape($username).'%\'',
		'LIMIT'	    => 10
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($result) > 0) {
		
		$data = array();
		while ($pm = $forum_db->fetch_assoc($result)) {
	           $data[] = $pm['username'];
	    }
		
		echo json_encode($data);
	   
	    die;
	}
}

else if ($action == 'get_inbox')
{
	$user = isset($_GET['user']) ? $_GET['user'] : null;
	
	if ($user != null) {
 
        global $forum_db, $forum_user;
		
		$query = array(
			'SELECT'	=> 'u.id',
			'FROM'		=> 'users AS u',
			'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'pun_pm_messages AS pm',
				    'ON'			=> '(pm.sender_id=u.id)'
			    ),
		    ),
			'WHERE'		=> 'u.username=\''.$user.'\' AND pm.receiver_id=\''.$forum_user['id'].'\' AND pm.deleted_by_receiver=0 AND (pm.status = \'delivered\' OR status = \'read\')',
			'GROUP BY'	=> 'username',
			'LIMIT'		=> '1'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$sender = $forum_db->result($result);

		if ($sender)
		{
			setcookie("inbox_pm_sender", $sender, time()+900, "/");

			echo 1;
		}
    }
}

else if ($action == 'get_outbox')
{
	$user = isset($_GET['user']) ? $_GET['user'] : null;
	
	if ($user != null) {
 
        global $forum_db, $forum_user;
		
		$query = array(
			'SELECT'	=> 'u.id',
			'FROM'		=> 'users AS u',
			'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'pun_pm_messages AS pm',
				    'ON'			=> '(pm.receiver_id=u.id)'
			    ),
		    ),
			'WHERE'		=> 'u.username=\''.$user.'\' AND pm.sender_id=\''.$forum_user['id'].'\' AND pm.deleted_by_sender=0',
			'GROUP BY'	=> 'username',
			'LIMIT'		=> '1'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$receiver = $forum_db->result($result);

		if ($receiver)
		{
			setcookie("outbox_pm_receiver", $receiver, time()+900, "/");

			echo 1;
		}
    }
}


